=== debian/changelog ===
android-platform-tools (34.0.4-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:38:29 +0000

android-platform-tools (34.0.4-1build2) noble; urgency=high

  * No change rebuild against libprotobuf32t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:48:50 +0100

android-platform-tools (34.0.4-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:01:04 +0000

android-platform-tools (34.0.4-1) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Mon, 21 Aug 2023 00:22:39 -0700

android-platform-tools (34.0.4-1~exp3) experimental; urgency=medium

  * Revert "debian/patches: Remove unused patch".
  * debian/libext4_utils.mk:
    - Remove CXXFLAGS already existing in debian/rules.

 -- Roger Shimizu <rosh@debian.org>  Tue, 08 Aug 2023 22:40:56 -0700

android-platform-tools (34.0.4-1~exp2) experimental; urgency=medium

  * debian/patches:
    - Remove unused patch.
    - Revert patch to avoid introduce new dependency.
  * debian/rules: Sync formating with boringssl.

 -- Roger Shimizu <rosh@debian.org>  Mon, 07 Aug 2023 00:07:46 -0700

android-platform-tools (34.0.4-1~exp1) experimental; urgency=medium

  * New upstream release 34.0.4
  * debian/*.install: Remove system/unwinding/libbacktrace.
  * debian/fastboot.mk: Add new source files.
  * debian/patches: Add revert patch to avoid ftbfs.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jul 2023 21:20:36 -0700

android-platform-tools (33.0.4-1~exp4) experimental; urgency=medium

  * debian/libbacktrace.mk: Add RegsRiscv64.cpp.
  * debian/*.mk: Move c&cpp std version to debian/rules.

 -- Roger Shimizu <rosh@debian.org>  Fri, 28 Jul 2023 19:13:42 -0700

android-platform-tools (33.0.4-1~exp3) experimental; urgency=medium

  * debian/patches:
    - Restore previously removed for gcc only patches.
    - Move all revert patches to folder 'revert'.
  * debian/control:
    - pandoc are not available for some arch-es now, move to use ronn.

 -- Roger Shimizu <rosh@debian.org>  Fri, 28 Jul 2023 00:16:45 -0700

android-platform-tools (33.0.4-1~exp2) experimental; urgency=medium

  * debian/patches:
    - Restore mips related patch.
    - Add include dir to makefile instead of patching.
    - Remove unused patches.

 -- Roger Shimizu <rosh@debian.org>  Thu, 27 Jul 2023 20:19:10 -0700

android-platform-tools (33.0.4-1~exp1) experimental; urgency=medium

  * New upstream release 33.0.4
  * debian/patches:
    - Refresh patches.
    - Add patch to fix ftbfs.
    - Revert upstream's removal of simg2simg.

 -- Roger Shimizu <rosh@debian.org>  Thu, 27 Jul 2023 01:56:00 -0700
